-- Really needc to rewrite this, but it's a bit of a pain to do in general
local Movers = {headers = {["party"] = true, ["raid"] = true}, childHeaders = {["partypet"] = "party", ["partytarget"] = "party"}}
local L = ShadowUFLocals
local frameList, dummyPosition = {}, {}
ShadowUF:RegisterModule(Movers, "movers")

local function OnEnter(self)
	local text = self.tooltipText or self.overrideText or L.units[self.unitType] or self.unitType or self.unit
	if( text ) then
		GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT")
		GameTooltip:SetText(text, 0.90, 0.90, 0.90, 0.90, true)
	end
end

local function OnLeave(self)
	GameTooltip:Hide()
end

function Movers:Enable()
	-- Enable it for all units that are enabled
	for _, unit in pairs(ShadowUF.units) do
		if( ShadowUF.db.profile.units[unit].enabled ) then
			if( not self.childHeaders[unit] ) then
				if( not self.headers[unit] ) then
					self:CreateFrame(unit, unit)
				else
					self:CreateHeader(unit)
				end
			end
		else
			for _, frame in pairs(frameList) do
				if( frame.unit == unit or frame.unitType == unit ) then
					if( frame.children ) then
						for _, child in pairs(frame.children) do
							child:Hide()
						end
					end
					
					frame:Hide()
				end
			end
		end
	end
	
	if( self.infoFrame ) then
		self.infoFrame:Show()
		return
	end
	
	-- Show an info frame that users can lock the frames through
	local frame = CreateFrame("Frame", nil, UIParent)
	frame:SetClampedToScreen(true)
	frame:SetWidth(300)
	frame:SetHeight(115)
	frame:RegisterForDrag("LeftButton")
	frame:EnableMouse(true)
	frame:SetMovable(true)
	frame:SetScript("OnDragStart", function(self)
		self:StartMoving()
	end)
	frame:SetScript("OnDragStop", function(self)
		self:StopMovingOrSizing()
	end)
	frame:SetBackdrop({
		  bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		  edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
		  edgeSize = 26,
		  insets = {left = 9, right = 9, top = 9, bottom = 9},
	})
	frame:SetBackdropColor(0, 0, 0, 0.85)
	frame:SetPoint("CENTER", UIParent, "CENTER", 0, 225)

	frame.titleBar = frame:CreateTexture(nil, "ARTWORK")
	frame.titleBar:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	frame.titleBar:SetPoint("TOP", 0, 8)
	frame.titleBar:SetWidth(350)
	frame.titleBar:SetHeight(45)

	frame.title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	frame.title:SetPoint("TOP", 0, 0)
	frame.title:SetText("Shadowed Unit Frames")

	frame.text = frame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	frame.text:SetText(L["The black boxes are used for positioning all enabled unit frames.\n\nYou can hide them by locking them through /shadowuf or clicking the button below."])
	frame.text:SetPoint("TOPLEFT", 12, -22)
	frame.text:SetWidth(frame:GetWidth() - 20)
	frame.text:SetJustifyH("LEFT")

	frame.lock = CreateFrame("Button", nil, frame, "UIPanelButtonTemplate")
	frame.lock:SetText(L["Lock frames"])
	frame.lock:SetHeight(20)
	frame.lock:SetWidth(100)
	frame.lock:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 6, 8)
	frame.lock:SetScript("OnEnter", OnEnter)
	frame.lock:SetScript("OnLeave", OnLeave)
	frame.lock.tooltipText = L["Locks the unit frame positionings hiding the mover boxes."]
	frame.lock:SetScript("OnClick", function()
		ShadowUF.db.profile.locked = true
		Movers:Update()
	end)

	frame.unlink = CreateFrame("Button", nil, frame, "UIPanelButtonTemplate")
	frame.unlink:SetText(L["Unlink frames"])
	frame.unlink:SetHeight(20)
	frame.unlink:SetWidth(100)
	frame.unlink:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -6, 8)
	frame.unlink:SetScript("OnEnter", OnEnter)
	frame.unlink:SetScript("OnLeave", OnLeave)
	frame.unlink.tooltipText = L["WARNING: This will unlink all frames from each other so you can move them without another frame moving with it."]
	frame.unlink:SetScript("OnClick", function()
		for unit, frame in pairs(frameList) do
			if( unit == frame.unitType and ShadowUF.db.profile.positions[unit] ) then
				if( frame.children ) then
					frame.children[1]:GetScript("OnDragStart")(frame.children[1])
					frame.children[1]:GetScript("OnDragStop")(frame.children[1])
				else
					frame:GetScript("OnDragStart")(frame)
					frame:GetScript("OnDragStop")(frame)
				end
			end
		end
		
		Movers:Update()
	end)

	self.infoFrame = frame
end

local function OnDragStart(self)
	self = frameList[self.unitType] or self
	self.isMoving = true
	self.parentMoving = nil
	self:StartMoving()
	
	local parent = ShadowUF.Units.unitFrames[self.unitType] or ShadowUF.Units.unitFrames[self.unit]
	if( parent ) then
		self.parent = parent

		parent:SetAllPoints(self)
	end
end

-- TL = GetLeft/GetTop
-- TR = GetRight/GetTop
-- BL = GetLeft/GetBottom
-- BR = GetRight/GetBottom
-- C = GetCenter
local function OnDragStop(self)
	self = frameList[self.unitType] or self
	self.isMoving = false
	self:StopMovingOrSizing()
	
	-- When dragging the frame around, Blizzard changes the anchoring based on the closet portion of the screen
	-- When a widget is near the top left it uses top left, near the left it uses left and so on
	-- this provides a problem because it can lead to widgests having messed up anchoring
	-- which matters for header frames especially with dynamic heights and widths
	local scale = self:GetEffectiveScale()
	local position = ShadowUF.db.profile.positions[self.unitType]
	local point, _, relativePoint, x, y = self:GetPoint()
	
	-- If the user is still using the template anchoring so will need to do some extra magic to it
	-- Internally, once the user moves a frame they are switched to the custom anchoring system, as far as the user is
	-- concerned they are still on the custom anchoring system
	local anchorType = position.anchorPoint or position.movedAnchor
	if( anchorType and anchorType ~= "" ) then
		local newPoint, newRelative
		local mainPoint = string.sub(anchorType, 0, 1)
		local subPoint = string.sub(anchorType, 2, 2)
		if( mainPoint == "T" ) then
			y = self:GetTop() * scale
			newRelative = "BOTTOMLEFT"
			newPoint = "TOP"
		elseif( mainPoint == "B" ) then
			y = self:GetBottom() * scale
			newRelative = "BOTTOMLEFT"
			newPoint = "BOTTOM"
		elseif( mainPoint == "C" ) then
			x, y = self:GetCenter()
			x = x * scale
			y = y * scale
			
			newPoint = "CENTER"
			newRelative = "BOTTOMLEFT"
			subPoint = ""
		end
		
		if( newPoint ) then
			if( subPoint == "L" ) then
				x = self:GetLeft() * scale
				newPoint = newPoint .. "LEFT"
			elseif( subPoint == "R" ) then
				x = self:GetRight() * scale
				newPoint = newPoint .. "RIGHT"
			end
		end
				
		-- New custom anchoring received, will use these instead of the ones Blizzard provides
		if( newPoint and newRelative ) then
			position.anchorPoint = nil
			position.movedAnchor = anchorType
			position.point = newPoint
			position.relativePoint = newRelative

		-- None found, default to whatever Blizzard provided
		else
			point, _, relativePoint, x, y = self:GetPoint()

			position.anchorPoint = ""
			position.movedAnchor = nil
			position.point = point
			position.relativePoint = relativePoint

			x = x * scale
			y = y * scale
		end
	else
		position.anchorPoint = ""
		position.movedAnchor = nil
		position.point = point
		position.relativePoint = relativePoint
		
		x = x * scale
		y = y * scale
	end
		
	position.anchorTo = "UIParent"
	position.x = x
	position.y = y
	
	ShadowUF.Layout:AnchorFrame(UIParent, self, ShadowUF.db.profile.positions[self.unitType])

	-- Unlock the parent frame from the mover now
	if( self.parent ) then
		ShadowUF.Layout:AnchorFrame(UIParent, self.parent, ShadowUF.db.profile.positions[self.parent.unitType])
	end
	
	-- Notify the configuration it can update itself now
	LibStub("AceConfigRegistry-3.0"):NotifyChange("ShadowedUF")
end

-- Handles the header creation to mimick all the frames they have
local function getRelativeAnchor(point)
	if( not point ) then return end
	if( point == "TOP") then
		return "BOTTOM", 0, -1
	elseif( point == "BOTTOM") then
		return "TOP", 0, 1
	elseif( point == "LEFT") then
		return "RIGHT", 1, 0
	elseif( point == "RIGHT") then
		return "LEFT", -1, 0
	elseif( point == "TOPLEFT") then
		return "BOTTOMRIGHT", 1, -1
	elseif( point == "TOPRIGHT") then
		return "BOTTOMLEFT", -1, -1
	elseif( point == "BOTTOMLEFT") then
		return "TOPRIGHT", 1, 1
	elseif( point == "BOTTOMRIGHT") then
		return "TOPLEFT", -1, 1
	else
		return "CENTER", 0, 0
	end
end

-- Need to make sure we keep the mover frames updated to what their owners would look like
local updateThrottle
function Movers:OnLayoutApplied(frame)
	local moverFrame = frameList[frame.unit]
	if( moverFrame and moverFrame:IsVisible() ) then
		ShadowUF.Layout:SetupFrame(moverFrame, ShadowUF.db.profile.units[moverFrame.unitType])
		
		moverFrame.text:SetWidth(moverFrame:GetWidth() - 10)
		moverFrame.text:SetHeight(moverFrame:GetHeight() - 10)
		
		-- Now reposition it
		-- Creating a dummy positioning table so we can keep the moving blocks anchored to each other as long as needed.
		if( moverFrame.unitType == moverFrame.unit or self.childHeaders[moverFrame.unitType] ) then
			if( not ShadowUF.db.profile.positions[frame.unitType] ) then return end
			
			for k in pairs(dummyPosition) do dummyPosition[k] = nil end
			for k, v in pairs(ShadowUF.db.profile.positions[frame.unitType]) do dummyPosition[k] = v end
			dummyPosition.anchorTo = string.gsub(dummyPosition.anchorTo, "#SUFUnit", "#SUFMover")
			dummyPosition.anchorTo = string.gsub(dummyPosition.anchorTo, "#SUFHeader", "#SUFMover")
									
			ShadowUF.Layout:AnchorFrame(moverFrame.parent or UIParent, moverFrame, dummyPosition)
		-- Bit hackish yes, but no sense in adding call backs for headers being updated
		elseif( not updateThrottle or updateThrottle < GetTime() ) then
			updateThrottle = GetTime() + 1
			
			Movers:CreateHeader(moverFrame.unitType)
		end
	end
end
		
function Movers:CreateHeader(type)
	local headerFrame = frameList[type] or CreateFrame("Frame", "SUFMover" .. type, UIParent)
	headerFrame:SetMovable(true)
	headerFrame.unitType = type
	headerFrame.unit = type
	
	frameList[type] = headerFrame
	
	-- Create frames for each child
	local alreadyLoaded = headerFrame.children
	
	updateThrottle = GetTime() + 1
	headerFrame.children = headerFrame.children or {}
			
	for id, unit in pairs(ShadowUF[type .. "Units"]) do
		self:CreateFrame(unit, type, string.format(L.headers[type], id))
		
		if( not alreadyLoaded ) then
			table.insert(headerFrame.children, frameList[unit])
		end
		
		for unitChild, unitParent in pairs(self.childHeaders) do
			if( unitParent == type ) then
				self:CreateFrame(unitChild .. id, unitChild, L.units[unitChild] .. " (" .. id .. ")", L["You cannot drag child units, they have to be repositioned using the configuration for their unit in /shadowuf."], frameList[unit])
			end
		end
	end
				
	-- Position all of the children headers so they mimick the real ones
	local config = ShadowUF.db.profile.units[type]
	local unitsPerColumn = config.unitsPerColumn or #(headerFrame.children)
	local maxUnits = 0
	if( config.filters ) then
		for _, enabled in pairs(config.filters) do
			if( enabled ) then
				maxUnits = maxUnits + 5
			end
		end
		
		if( unitsPerColumn > maxUnits ) then
			unitsPerColumn = maxUnits
		end
	else
		maxUnits = #(headerFrame.children)
	end
	
	local point = config.attribPoint or "TOP"
    local relativePoint, xOffsetMulti, yOffsetMulti = getRelativeAnchor(point)
    local xMultiplier, yMultiplier = math.abs(xOffsetMulti), math.abs(yOffsetMulti)
	local columnRelativePoint, colxMulti, colyMulti = getRelativeAnchor(config.attribAnchorPoint)
    local maxColumns = config.maxColumns or 1
	local totalDisplayed = math.min(maxUnits, (maxColumns * unitsPerColumn))
	local numColumns = math.ceil(totalDisplayed / unitsPerColumn)
    local x = (config.offset or 0) * xOffsetMulti
    local y = (config.offset or 0) * yOffsetMulti
		
	-- Position all of the children
	local columnTotal = 0
	for id, child in pairs(headerFrame.children) do
		columnTotal = columnTotal + 1
		if( numColumns > 0 and columnTotal > unitsPerColumn ) then
			columnTotal = 1
		end
				
		if( id == 1 ) then
			child:ClearAllPoints()
			child:SetPoint(point, headerFrame, point, 0, 0)
			
			if( config.attribAnchorPoint and numColumns > 1 ) then
				child:SetPoint(config.attribAnchorPoint, headerFrame, config.attribAnchorPoint, 0, 0)
			end
		elseif( columnTotal == 1 ) then
			child:ClearAllPoints()
			child:SetPoint(config.attribAnchorPoint, headerFrame.children[id - unitsPerColumn], columnRelativePoint, colxMulti * config.columnSpacing, colyMulti * config.columnSpacing)
		else
			child:ClearAllPoints()
			child:SetPoint(point, headerFrame.children[id - 1], relativePoint, xMultiplier * x, yMultiplier * y)
		end
	end

	-- Figure out the size of the total header
	local width = xMultiplier * ( unitsPerColumn - 1 ) * config.width + ( ( unitsPerColumn - 1 ) * ( x * xOffsetMulti ) ) + config.width
	local height = yMultiplier * ( unitsPerColumn - 1 ) * config.height + ( ( unitsPerColumn - 1 ) * ( y * yOffsetMulti ) ) + config.height

	if( numColumns > 1 ) then
		width = width + ( ( numColumns - 1 ) * math.abs(colxMulti) * ( width + config.columnSpacing ) )
		height = height + ( ( numColumns - 1 ) * math.abs(colyMulti) * ( height + config.columnSpacing ) )
	end
	
	headerFrame:SetHeight(height)
	headerFrame:SetWidth(width)
		
	-- Now set which of the frames is shown vs hidden
	for id, frame in pairs(headerFrame.children) do
		if( id <= totalDisplayed ) then
			frame:Show()
		else
			frame:Hide()
		end
	end
	
	-- Position the header
	for k in pairs(dummyPosition) do dummyPosition[k] = nil end
	for k, v in pairs(ShadowUF.db.profile.positions[type]) do dummyPosition[k] = v end
	dummyPosition.anchorTo = string.gsub(dummyPosition.anchorTo, "#SUFUnit", "#SUFMover")
	dummyPosition.anchorTo = string.gsub(dummyPosition.anchorTo, "#SUFHeader", "#SUFMover")

	ShadowUF.Layout:AnchorFrame(UIParent, headerFrame, dummyPosition)
end

function Movers:CreateFrame(unit, unitType, overrideText, tooltipText, parent)
	if( frameList[unit] ) then
		frameList[unit]:Show()
		self:OnLayoutApplied(frameList[unit])
		return
	end
	
	local moverFrame = CreateFrame("Frame", "SUFMover" .. unit, UIParent)
	moverFrame:SetScript("OnDragStart", OnDragStart)
	moverFrame:SetScript("OnDragStop", OnDragStop)
	moverFrame:SetScript("OnEnter", OnEnter)
	moverFrame:SetScript("OnLeave", OnLeave)
	moverFrame:SetFrameStrata("DIALOG")
	moverFrame:SetClampedToScreen(true)
	moverFrame:EnableMouse(true)
	moverFrame.text = moverFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	moverFrame.text:SetText(overrideText or L.units[unitType] or unitType)
	moverFrame.text:SetPoint("CENTER", moverFrame, "CENTER")
	moverFrame.unitType = unitType
	moverFrame.unit = unit
	moverFrame.ignoreAnchor = true
	moverFrame.parent = parent
	moverFrame.tooltipText = tooltipText
	moverFrame.overrideText = overrideText
	
	if( not self.childHeaders[unitType] ) then
		moverFrame:RegisterForDrag("LeftButton")
		moverFrame:SetMovable(true)
	end
	
	frameList[unit] = moverFrame
	
	self:OnLayoutApplied(moverFrame)
end

function Movers:Update()
	if( not ShadowUF.db.profile.locked ) then
		self:Enable()
	elseif( ShadowUF.db.profile.locked ) then
		self:Disable()
	end
end

function Movers:Disable()
	for _, frame in pairs(frameList) do
		if( frame.isMoving ) then
			OnDragStop(frame)
		end
		
		frame:Hide()
	end
	
	if( self.infoFrame ) then
		self.infoFrame:Hide()
	end
end
